;A few procedures for drawing shaded lines,rectangles,triangles and quads.
;NOTE:
;Works only with Windows 98/ME,Windows 2000 and Windows XP (needs msimg32.dll)

#GRADIENT_FILL_RECT_H=0
#GRADIENT_FILL_RECT_V=1
#GRADIENT_FILL_TRIANGLE=2
#GRADIENT_FILL_OP_FLAG=255

Structure TRIVERTEX
x.l
y.l
Red.w
Green.w
Blue.w
Alpha.w
EndStructure

Structure GRADIENT_RECT
UpperLeft.l
LowerRight.l
EndStructure

Structure _MyQuad
vertex.TRIVERTEX[4]
EndStructure

Structure _MyTriangle
vertex.TRIVERTEX[3]
EndStructure

Structure _MyRect
vertex.TRIVERTEX[2]
EndStructure

Structure _MyGRADIENT_QUAD
Vertex1.l
Vertex2.l
Vertex3.l
Vertex4.l
Vertex5.l
Vertex6.l
EndStructure

Structure _MyGRADIENT_TRIANGLE
Vertex1.l
Vertex2.l
Vertex3.l
EndStructure

Structure _MyPOLIGON_QUAD
X1.l
Y1.l
X2.l
Y2.l
X3.l
Y3.l
X4.l
Y4.l
EndStructure

Structure _MyPOLIGON_TRIANGLE
X1.l
Y1.l
X2.l
Y2.l
X3.l
Y3.l
EndStructure


Global Msimg32,Gdi32
Global Img32_GradientFill,Gdi32_LineDDA
Global Img32_FirstColorR,Img32_FirstColorG,Img32_FirstColorB
Global Img32_LastColorR,Img32_LastColorG,Img32_LastColorB
Global Img32_StartX.f,Img32_StartY.f,Img32_EndX.f,Img32_EndY.f,Img32_hDC
Global Img32_PointsToDraw.f

Procedure _InternImg32_LineDDAProc(X,Y,dummy)
v1.f=Sqr((Img32_StartX-X)*(Img32_StartX-X)+(Img32_StartY-Y)*(Img32_StartY-Y))/Img32_PointsToDraw
v2.f=1-v1
SetPixelV_(Img32_hDC,X,Y,RGB(Img32_FirstColorR*v2+Img32_LastColorR*v1,Img32_FirstColorG*v2+Img32_LastColorG*v1,Img32_FirstColorB*v2+Img32_LastColorB*v1))
EndProcedure


Procedure Img32_Init()
Msimg32=LoadLibrary_("Msimg32.dll")
Gdi32=LoadLibrary_("Gdi32.dll")
If Msimg32:Img32_GradientFill=GetProcAddress_(Msimg32,"GradientFill"):EndIf
If Gdi32:Gdi32_LineDDA=GetProcAddress_(Gdi32,"LineDDA"):EndIf
If Img32_GradientFill=0 Or Gdi32_LineDDA=0:ProcedureReturn 0:EndIf
ProcedureReturn -1
EndProcedure

Procedure Img32_Free()
If Img32_GradientFill
Img32_GradientFill=0
FreeLibrary_(Msimg32)
EndIf
If Gdi32_LineDDA
Gdi32_LineDDA=0
FreeLibrary_(Gdi32)
EndIf
ProcedureReturn -1
EndProcedure


;(x1,y1)    (x2,y2)
; +------------+
; |            |
; |            |
; |            |
; |            |
; +------------+
;(x4,y4)    (x3,y3)
Procedure Img32_DrawQuad2D(hDC,x1,y1,x2,y2,x3,y3,x4,y4,C1,C2,C3,C4)
v._MyQUAD\vertex[0]\x=x1
v\vertex[0]\y=y1
v\vertex[0]\Red=(C1&$FF)<<8+$FF
v\vertex[0]\Green=C1&$FF00
v\vertex[0]\Blue=(C1&$FF0000)>>8
v\vertex[1]\x=x2
v\vertex[1]\y=y2
v\vertex[1]\Red=(C2&$FF)<<8+$FF
v\vertex[1]\Green=C2&$FF00
v\vertex[1]\Blue=(C2&$FF0000)>>8
v\vertex[2]\x=x3
v\vertex[2]\y=y3
v\vertex[2]\Red=(C3&$FF)<<8
v\vertex[2]\Green=C3&$FF00
v\vertex[2]\Blue=(C3&$FF0000)>>8
v\vertex[3]\x=x4
v\vertex[3]\y=y4
v\vertex[3]\Red=(C4&$FF)<<8
v\vertex[3]\Green=C4&$FF00
v\vertex[3]\Blue=(C4&$FF0000)>>8

Indices._MyGRADIENT_QUAD\Vertex1=0
Indices\Vertex2=1
Indices\Vertex3=2
Indices\Vertex4=2
Indices\Vertex5=3
Indices\Vertex6=0

If (C1=C2 And C3=C4 And C2=C3) Or Img32_GradientFill=0
p._MyPOLIGON_QUAD\X1=X1
p\Y1=Y1
p\X2=X2
p\Y2=Y2
p\X3=X3
p\Y3=Y3
p\X4=X4
p\Y4=Y4
OldBrush=SelectObject_(hDC,CreateSolidBrush_(C1))
OldPen=SelectObject_(hDC,GetStockObject_(#NULL_PEN))
Result=Polygon_(hDC,p,4)
SelectObject_(hDC,OldPen)
DeleteObject_(SelectObject_(hDC,OldBrush))
ProcedureReturn Result
EndIf
If Img32_GradientFill
ProcedureReturn CallFunctionFast(Img32_GradientFill,hDC,v,4,Indices,2,#GRADIENT_FILL_TRIANGLE)
EndIf
EndProcedure



;(x1,y1)
; +
; |\
; | \
; |  \
; |   \
; |    \
; |     \
; |      \
; |       \
; +--------+
;(x3,y3)  (x2,y2)
Procedure Img32_DrawTriangle2D(hDC,x1,y1,x2,y2,x3,y3,C1,C2,C3)
v._MyTRIANGLE\vertex[0]\x=x1
v\vertex[0]\y=y1
v\vertex[0]\Red=(C1&$FF)<<8+$FF
v\vertex[0]\Green=C1&$FF00
v\vertex[0]\Blue=(C1&$FF0000)>>8
v\vertex[1]\x=x2
v\vertex[1]\y=y2
v\vertex[1]\Red=(C2&$FF)<<8+$FF
v\vertex[1]\Green=C2&$FF00
v\vertex[1]\Blue=(C2&$FF0000)>>8
v\vertex[2]\x=x3
v\vertex[2]\y=y3
v\vertex[2]\Red=(C3&$FF)<<8
v\vertex[2]\Green=C3&$FF00
v\vertex[2]\Blue=(C3&$FF0000)>>8

Indices._MyGRADIENT_TRIANGLE\Vertex1=0
Indices\Vertex2=1
Indices\Vertex3=2

If (C1=C2 And C2=C3) Or Img32_GradientFill=0
p._MyPOLIGON_TRIANGLE\X1=X1
p\Y1=Y1
p\X2=X2
p\Y2=Y2
p\X3=X3
p\Y3=Y3
OldBrush=SelectObject_(hDC,CreateSolidBrush_(C1))
OldPen=SelectObject_(hDC,GetStockObject_(#NULL_PEN))
Result=Polygon_(hDC,p,3)
SelectObject_(hDC,OldPen)
DeleteObject_(SelectObject_(hDC,OldBrush))
ProcedureReturn Result
EndIf
If Img32_GradientFill
ProcedureReturn CallFunctionFast(Img32_GradientFill,hDC,v,3,Indices,1,#GRADIENT_FILL_TRIANGLE)
EndIf
EndProcedure

Procedure Img32_DrawRectH2D(hDC,x,y,width,height,C1,C2)
v._MyRect\vertex[0]\x=x
v\vertex[0]\y=y
v\vertex[0]\Red=(C1&$FF)<<8+$FF
v\vertex[0]\Green=C1&$FF00
v\vertex[0]\Blue=(C1&$FF0000)>>8
v\vertex[1]\x=x+width
v\vertex[1]\y=y+height
v\vertex[1]\Red=(C2&$FF)<<8+$FF
v\vertex[1]\Green=C2&$FF00
v\vertex[1]\Blue=(C2&$FF0000)>>8

Rect.GRADIENT_RECT\UpperLeft=0
Rect\LowerRight=1

If (C1=C2) Or Img32_GradientFill=0
If width>0 And height>0
OldBrush=SelectObject_(hDC,CreateSolidBrush_(C1))
OldPen=SelectObject_(hDC,GetStockObject_(#NULL_PEN))
Result=Rectangle_(hDC,x,y,x+width,y+height)
SelectObject_(hDC,OldPen)
DeleteObject_(SelectObject_(hDC,OldBrush))
EndIf
ProcedureReturn Result
EndIf
If Img32_GradientFill
ProcedureReturn CallFunctionFast(Img32_GradientFill,hDC,v,2,Rect,1,#GRADIENT_FILL_RECT_H)
EndIf
EndProcedure

Procedure Img32_DrawRectV2D(hDC,x,y,width,height,C1,C2)
v._MyRect\vertex[0]\x=x
v\vertex[0]\y=y
v\vertex[0]\Red=(C1&$FF)<<8+$FF
v\vertex[0]\Green=C1&$FF00
v\vertex[0]\Blue=(C1&$FF0000)>>8
v\vertex[1]\x=x+width
v\vertex[1]\y=y+height
v\vertex[1]\Red=(C2&$FF)<<8+$FF
v\vertex[1]\Green=C2&$FF00
v\vertex[1]\Blue=(C2&$FF0000)>>8

Rect.GRADIENT_RECT\UpperLeft=0
Rect\LowerRight=1
If (C1=C2) Or Img32_GradientFill=0
If width>0 And height>0
OldBrush=SelectObject_(hDC,CreateSolidBrush_(C1))
OldPen=SelectObject_(hDC,GetStockObject_(#NULL_PEN))
Result=Rectangle_(hDC,x,y,x+width,y+height)
SelectObject_(hDC,OldPen)
DeleteObject_(SelectObject_(hDC,OldBrush))
EndIf
ProcedureReturn Result
EndIf
If Img32_GradientFill
ProcedureReturn CallFunctionFast(Img32_GradientFill,hDC,v,2,Rect,1,#GRADIENT_FILL_RECT_V)
EndIf
EndProcedure


Procedure Img32_DrawLine2D(hDC,x1,y1,x2,y2,C1,C2)
If (C1=C2) Or Gdi32_LineDDA=0
OldPen=SelectObject_(hDC,CreatePen_(#PS_SOLID,1,C1))
MoveToEx_(hDC,x1,y1,0)
Result=LineTo_(hDC,x2,y2)
DeleteObject_(SelectObject_(hDC,OldPen))
ProcedureReturn Result
EndIf
If Gdi32_LineDDA
Img32_FirstColorR=Red(C1)
Img32_FirstColorG=Green(C1)
Img32_FirstColorB=Blue(C1)
Img32_LastColorR=Red(C2)
Img32_LastColorG=Green(C2)
Img32_LastColorB=Blue(C2)
Img32_StartX=X1
Img32_StartY=Y1
Img32_EndX=X2
Img32_EndX=Y2
Img32_PointsToDraw=Pow(Pow((x2-x1),2)+Pow((y2-y1),2),0.5)
Img32_hDC=hDC
ProcedureReturn CallFunctionFast(Gdi32_LineDDA,X1,Y1,X2,Y2,@_InternImg32_LineDDAProc(),0)
EndIf
EndProcedure





;Example:
Img32_Init()
Flags=#PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_ScreenCentered 

OpenWindow(1,0,0,500,300,Flags,"Img32-test")

Repeat

Event=WaitWindowEvent()

If Event=#WM_PAINT
hDC=StartDrawing(WindowOutput())

Img32_DrawQuad2D(hDC, 10, 10,110, 10,180,100, 20,110,#Magenta,#Black,#White,#Yellow)

Img32_DrawTriangle2D(hDC,250, 10,300,100,200,100,#Red,#Green,#Blue)

Img32_DrawRectH2D(hDC, 10,150,200,100,#Black,#White)

Img32_DrawRectV2D(hDC,250,150,200,100,#Red,#Blue)

Img32_DrawLine2D(hDC,350, 50,400,100,#Black,#White)
Img32_DrawLine2D(hDC,400,100,450, 50,#White,#Black)
Img32_DrawLine2D(hDC,450, 50,400,  0,#Black,#White)
Img32_DrawLine2D(hDC,400,  0,350, 50,#White,#Black)

StopDrawing()
EndIf

Until Event=#PB_Event_CloseWindow

Img32_Free()


